var keyring;

function validForm(name, email, password){
	
	// Marquem formulari com a vàlid per defecte
	var valid = true;
	
	// Comprovem que cap camp estigui buit
	if(name =="" || email =="" || password == ""){
		valid = false;
		missatgeModal("Si us plau ompli tots els camps del formulari");
	}
	
	// Comprovem que l'email etigui ben format
	var regex = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    if(!regex.test(email) && valid){
		valid = false;
		missatgeModal("L'email introduït no és vàlid");
	} 
	
	// Comprovem que el password tingui 8 caràcters com a mínim
	if(password.length < 8 && valid){
		valid = false;
		missatgeModal("Si us plau introdueixi una contrasenya d'almenys 8 caràcters");
	}
	
	return valid;
}

function generarParellClaus(){
  // Ocultem qualsevol missatge
  $('.alert').hide();
  // Obtenim referència al formulari
  var form = $('#generarClausForm');
  if(!validForm( form.find('#name').val(), form.find('#email').val(), form.find('#password').val())){
	  return false;
  }
  var opcions = {
          numBits: parseInt(form.find('#nombreBits').val(), 10),
          userId: form.find('#name').val() + ' <' + form.find('#email').val() + '>',
          passphrase: form.find('#password').val()
  };
  // Generem el parell de claus
  var keyPair = openpgp.generateKeyPair(opcions);
  keyPair.then(function(result) {
	// Importem la clau privada
    keyring.privateKeys.importKey(result.privateKeyArmored);
	// Importem la clau pública
    keyring.publicKeys.importKey(result.publicKeyArmored);
	//Emmagatzemem les claus al local storage
    keyring.store();
	// Refresquem la taula
	refrescaTaulaClaus(keyring.publicKeys.keys, keyring.privateKeys.keys);
	collapse();
	missatgeModal("Parell de claus generat correctament");
	// Buïdem camps del formulari
	form.find('#name').val("");
	form.find('#email').val("")
	form.find('#password').val("");
  });
  // Retornem fals per evitar que es recarregui la pàgina
  return false;
}

function afegeixRegistre(privateKey, publicKey, taulaId){
	
	// Obtenim el nombre de files que hem afegit fins ara
	var k = $("tr[id*=fila]").length;
	
	// Inicialitzem elements a afegir al HTML
	var elements = '<tr id="fila'+ k + '">' +
						'<td></td>'+
                        '<td class="name"></td>' +
                        '<td class="email"></td>' +
                        '<td>';
	
	var user = null, privateKeyValue = null, publicKeyValue = null;
	
	// Si estem tractant clau privada
	if(privateKey){
		// Recuperem usuari de la clau
		user = getUser(privateKey.users[0].userId.userid);
		
		// Mirem si la clau ja ha sigut afegida
		if ($("[email='" + user.userEmail + "']").length > 0){
			return;
		}
		
		// Obtenim clau text privada i pública
		privateKeyValue = privateKey.armor();
		publicKeyValue = privateKey.toPublic().armor();
		
		// Afegim els dos botons, mostrar clau pública i privada
		elements += '<button type="button" class="btn btn-info btn-xs" data-toggle="modal" data-target="#privada' + k + '" style="margin-left: 10px">Mostrar clau privada</button>'+
					'<button type="button" class="btn btn-info btn-xs" data-toggle="modal" data-target="#publica' + k + '" style="margin-left: 10px">Mostrar clau pública</button>'+
					// Modal Clau privada
					'<div class="modal fade" id="privada' + k + '" role="dialog">'+
						'<div class="modal-dialog">' +
							'<div class="modal-content">'+
								'<div class="modal-header">'+
									'<button type="button" class="close" data-dismiss="modal">&times;</button>'+
									'<h4 class="modal-title">Clau privada de '+ user.userEmail + '</h4>'+
								'</div>'+
								'<div class="modal-body">'+
									'<pre class="textClauPrivada"></pre>'+
								'</div>'+
								'<div class="modal-footer">'+
									'<button type="button" class="btn btn-default" data-dismiss="modal">Tancar</button>'+
								'</div>'+													
							'</div>'+
						'</div>' +
					'</div>'+
					// Modal Clau publica
					'<div class="modal fade" id="publica' + k + '" role="dialog">'+
						'<div class="modal-dialog">' +
							'<div class="modal-content">'+
							    '<div class="modal-header">'+
									'<button type="button" class="close" data-dismiss="modal">&times;</button>'+
									'<h4 class="modal-title">Clau pública de '+ user.userEmail + '</h4>'+
								'</div>'+
								'<div class="modal-body">'+
									'<pre class="textClauPublica"></pre>'+
								'</div>'+
								'<div class="modal-footer">'+
									'<button type="button" class="btn btn-default" data-dismiss="modal">Tancar</button>'+
								'</div>'+													
							'</div>'+
						'</div>' +
					'</div>';										
					
	}else{
		// Recuperem usuari de la clau
		user = getUser(publicKey.users[0].userId.userid);
		
		// Mirem si la clau ja ha sigut afegida
		if ($("[email='" + user.userEmail + "']").length > 0){
			return;
		}
		
		// Obtenim text clau pública
		publicKeyValue = publicKey.armor();
		
		// Si estem tractant clau pública solament afegim botó mostrar clau pública
		// Afegim els dos botons, mostrar clau pública i privada
		elements += '<button type="button" class="btn btn-info btn-xs" data-toggle="modal" data-target="#publica' + k + '" style="margin-left: 10px">Mostrar clau pública</button>'+
					// Modal Clau publica
					'<div class="modal fade" id="publica' + k + '" role="dialog">'+
						'<div class="modal-dialog">' +
							'<div class="modal-content">'+
							    '<div class="modal-header">'+
									'<button type="button" class="close" data-dismiss="modal">&times;</button>'+
									'<h4 class="modal-title">Clau pública de '+ user.userEmail + '</h4>'+
								'</div>'+
								'<div class="modal-body">'+
									'<pre class="textClauPublica"></pre>'+
								'</div>'+
								'<div class="modal-footer">'+
									'<button type="button" class="btn btn-default" data-dismiss="modal">Tancar</button>'+
								'</div>'+													
							'</div>'+
						'</div>' +
					'</div>';											
	}
	
	// En tots els casos afegim botó d'eliminar
	elements += '<button id="' + k + '" email="'+ user.userEmail + '" type="button" class="btn btn-danger btn-xs esborrar" style="margin-left: 10px">Esborrar</button>'+
					'</td>'+
					'<td>'+							
					'</tr>';
	
	// Afegim elements al HTML
	$(taulaId + '>tbody').append(elements);
		
	//Afegim dades al registre
	$(taulaId + ' #fila'+ k + ' .name').text(user.userName);
	$(taulaId + ' #fila'+ k + ' .email').text(user.userEmail);
	$(taulaId + ' #fila'+ k + ' .textClauPrivada').text(privateKeyValue);
	// Obtenim clau pública per a l'usuari
	$(taulaId + ' #fila'+ k + ' .textClauPublica').text(publicKeyValue);	
}

function refrescaTaulaClaus(publicKeys, privateKeys){
	
	// Id de la taula
	var taulaId = '#taulaClaus';
	
	// Esborrem totes les linees de la taula
	$(taulaId + '>tbody>tr').remove();
  
	// Primer recorrem les claus privades
	for(var k = 0; k < privateKeys.length; k++){	
		// Construïm element a afegir
		afegeixRegistre(privateKeys[k], undefined, taulaId);	
	}
	
	// Ara recorrem les claus públiques
	for(var k = 0; k < publicKeys.length; k++){
		// Construïm element a afegir
		afegeixRegistre(undefined, publicKeys[k], taulaId);	
	}	
	
	//Assignem funció d'esborrar a cada botó
	$(taulaId + ' .esborrar').click(function(e){
		//Eliminem de l'array l'element corresponent
		privateKeys.splice(e.currentTarget.id, 1);
		publicKeys.splice(e.currentTarget.id, 1);
		//Guardem les claus a l'anell
		keyring.store();
		//I les tornem a pintar
		refrescaTaulaClaus(publicKeys, privateKeys);
  });	
}

function importarClauPublica(){
  // Ocultem qualsevol missatge
  $('.alert').hide();
  // Obtenim la clau pública introduïda
  var clauPublica = $('#clauPublicaNova').val();
  // Tractem d'importar la clau introduïda
  var importResult = keyring.publicKeys.importKey(clauPublica);
  // Verifiquem estat de l'import
  if (importResult === null){
    // Tot ha anat bé, guardem la clau
	keyring.store();
	// I actualitzem la taula
	refrescaTaulaClaus(keyring.publicKeys.keys, keyring.privateKeys.keys);
	collapse();
	// Mostrem missatge
	missatgeModal("Clau importada correctament");
	//Buïdem camps formulari
	$('#clauPublicaNova').val("");
  }else{
	// En cas contrari, mostrem missatge d'error
    $('#importarClausForm').prepend('<div id="importError" class="alert alert-danger"></div>');
    $('#importarClausForm' + ' #importError').text(importResult);	  
  }
  // Retornem fals per evitar que es recarregui la pàgina
  return false;
}

function missatgeModal(missatge){
	
	$('#cosMissatge').html(missatge);
	$('#missatgeModal').modal();
}

function getUser(user){
       try{
           var userName = user.substring(0,user.indexOf('<')-1);
           var userEmail = user.substring(user.indexOf('<')+1,user.indexOf('>'));
           if(user.indexOf('<') === -1){ 
            if(user.indexOf('@') === -1){
                throw "No Email Address";}
            userName = '';
            userEmail = user.substring(0, user.indexOf(' '));
            if(userEmail.substring(0,userEmail.indexOf(',')) != -1){
                userEmail = user.substring(0, user.indexOf(','));
                }
            if(userEmail.length === 0){
                userEmail = user;
            }
           }
           return {userName: userName, userEmail: userEmail, error: null};
       }
       catch(e){
           return {userName: '', userEmail: '', error: 'No User Found'};
       }
    }

function linkLocalFunction(event){
  // Ocultem tots els missatges
  $('.alert').hide();
  // Ocultem tots els <span>
  $('span').hide();
  // Mostrem solament el <span> que hem polsat
  if(event && event.currentTarget){
    $(event.currentTarget.hash).show();
  }
}

function collapse(element){
  // Colapsem tots els elements
  $('.jumbotron>.collapse').removeClass('in');
}

function onLoad(){
	
  // Inicialitzem anell de claus
  keyring = new openpgp.Keyring();

  // Refresquem la taula de claus
  refrescaTaulaClaus(keyring.publicKeys.keys, keyring.privateKeys.keys);
 
  // Assignem funcions al menú de navegació
  $('.link').click(linkLocalFunction);
  // Per defecte, quan carrega la pàgina, mostrem solament 
  // #inici i ocultem la resta
  $('#inici').show();
  $('#gestioClaus').hide();
  
    
  // Asignem funcions per els diferents formularis
  $('#generarClausSubmit').click(generarParellClaus);
  $('#importarClausSubmit').click(importarClauPublica);
  
  // Asignem funcions als botons de generar e importar clau
  $('#botoGenerar').click(collapse);
  $('#botoImportar').click(collapse);  
}

$(document).ready(onLoad());
