var sanitizeHtml = require('sanitizeHtml');
var rootElement = $(document);

function getContents(form, event){

  var msg;
  // Obtenim <div> que conté el missatge a enviar
  var textArea = $(event.currentTarget).parents('.I5').find('[g_editable]').first();
  if (textArea && textArea.length > 0 && textArea.html()) {
	// Busquem totes les etiquetes <div> i les substituim per un intro '\n'
	// Aixó és degut a que cada enter que introduim en el correu, s'afegeix com a un nou <div>
    msg = textArea.html().replace(/(<div>)/g,'\n');
	// Eliminem les etiquetes que tanquen els <div>
    msg = msg.replace(/(<\/div>)/g,'');
    return {textArea: textArea, msg: msg};
  }
}

function setContinguts(contents, message){
  if (contents.textArea) {
	// Substituim els enters pel tag <br/>
    message = message.split('\n').join('<br/>');
	// Assignem el missatge xifrat a l'àrea de text
    contents.textArea.html(message);
  }
}

function getDestinataris(form, event){
  // Creem JSON buit per a guardar els destinataris
  var destinataris = {};
  // Creem array email dins el JSON
  destinataris.email = [];
  // Obtenim <div> que conté tots els destinataris
  var emailsParent = $(event.currentTarget).parents('.I5').find('[email]').last().parent().parent();
  if (emailsParent && emailsParent.length > 0) {
    // Busquem tots els destinataris (elements amb atribut email) i afegim cada destinatari a l'array
	emailsParent.find('[email]').each(function() {
      destinataris.email.push($(this).attr("email"));
    });
  }
  return destinataris;
}

// Posem per defecte que no hi ha cap comunicació pendent amb la pàgina de Bakcground
var trucadaPendentBackground = false;
function callBackground(event){
  // Si hi ha alguna comunicació pendent amb la pàgina de background, no fem res
  if (trucadaPendentBackground) {
    return;
  }
  // Recuperem el formulari que conté els destinataris i l'assumpte del correu
  var form = $(event.currentTarget).parents('.I5').find('form');
  form.find('.alert').hide();
  
  // Obtenim el contingut del missatge
  var contents = getContents(form, event);
  
  // Obtenim password en cas de que aparegui
  var password;
  if (form.find('#passwordXifrat')){
	password = form.find('#passwordXifrat').val();
  }
  
  // Recuperem els destinataris
  var destinataris = getDestinataris(form, event);
  
  // Obtenim el remitent del correu 
  var from = $('.gb_ga').closest(':contains("@")').find(':contains("@")').text();

  // Deshabilitem el botó que a provocat l'acció fins que s'acabi de processar l'acció corresponent
  $(event.currentTarget).parent().find('[class*=btn]').addClass('disabled');

  // Posem que hi ha una crida pendent a la pàgina de background
  trucadaPendentBackground = true;
  
  // Cridem a la pàgina Bakcground per a processar la petició
  callExtension({method: event.data.action, recipients: destinataris, from: from, message: contents.msg, password: password})
  .then(function(response) {
	// Si la resposta es error
    if(response.type && response.type == "error") {
      mostraMissatge(response, form);
    }
	// Tornem a habilitar el botó que ha provocat l'acció
    $(event.currentTarget).parent().find('[class*=btn]').removeClass('disabled');
	
	// Marquem com finalitzada la crida a la pagina background
    trucadaPendentBackground = false;
	
	// Escrivim el resultat a la pantalla
    setContinguts(contents, response);
  });
}

function getMissatge(context){
  var msg;
  // Obtenim el <div> que conté el missatge a desxifrar
  var element = $(event.currentTarget).closest('div[class="gs"]').find('[class*="ii gt"] div');
  // Eliminem possibles intros
  msg = element.html().replace(/\n/g,"");
  // Substituim espais afegits per Gmail al final del missatge per intros
  msg = msg.replace(/(<br><\/div>)/g,'\n'); 
  // Substituim les etiquetes </div> per un intro
  msg = msg.replace(/(<\/div>)/g,'\n');
  // Substituim tots els <br> per intros
  msg = msg.replace(/(<br.*?>)/g,'\n');

  // Eiliminem tots els tags HTML restants
  msg = msg.replace(/<(.*?)>/g,'');
  
  // Retornem l'element <div> que conté el missatge i el missatge processat
  return [element, msg];
}

//function desxifrarAndVerify(event){
function desxifrar(event){	
  // Ocultem missatge d'error en cas de que sigui visible
  rootElement.find('.alert').hide();
  // Obtenim el pssword introuït
  var password = $(this).parent().parent().find('form[class="form-inline"] input[type="password"]').val();
  var context = this;
  // Obtenim missatge i <div> que conté el missatge
  var divMissatge = getMissatge(context);
  var element = divMissatge[0];
  var msg = divMissatge[1];
  // Obtenim email del remitent del missatge
  var remitent = $(context).parents('div[class="gE iv gt"]').find('span [email]').attr('email');
  // Cridem a la pàgina background de l'extensió per a desxifrar el missatge
  chrome.extension.sendRequest({method: event.data.action, senderEmail:remitent, msg: msg, password: password}, function(response){
    $.each(response.status, function(key, status) {
      $(context).parents('div[class="gE iv gt"]').append(status.html);
    });
	// Si el missatge ha estat desxifrat
    if (response.decrypted) {
      var text;
      if (response.result.text) {
        text = response.result.text;
      }
      else {
        text = response.result;
      }
      
	  // Netejem HTML resultant
      text = sanitizeHtml(text.replace(/\n/g,'<br>'));
      element.html(text);
    }
  });
}

function mostraMissatge(alert, form) {
  if(form) {
    var alertInForm = form.find('#'+alert.id);
    if (alertInForm && alertInForm.length > 0) {
      alertInForm.show();
      return;
    }
  }
  mostrarMissatgeModal(alert.html);
}

function mostrarMissatgeModal(message) {
  $('#cosMissatgeModal').html(message);
  $('#missatgeModal').modal('show');
}

function callExtension(request) {
  // Creem un objecte Deferred
  var deferred = $.Deferred();
  
  // Fem la crida a la pàgina background
  chrome.extension.sendRequest(request, function(response){
	// Resolem la crida quan la pàgina background ens respongui
    deferred.resolve(response);
  });
  // Retornem la promesa per a poder gestionar la resposta posteriorment
  return deferred.promise();
}

function composeInserted(ev) {
  // Busquem la linia de la taula (TR) on estan les eines d'escriptura i el botó Send
  // per afegir les accions necessàries
  var trEines = $('.n1tfz');
  // Si hem trobat la fila d'eines 
  if (trEines && trEines.length > 0) {
	// Per a cada fila d'eines afegim les accions corresponents
    trEines.each(function(){
	  // Obtenim la taula
      var taulaEines = $(this).parent().parent().parent();
	  // Si hem pogut obtenir la taula d'Eines i no hem afegit abans les opcions de xifrar
      if (taulaEines && taulaEines.length> 0 && taulaEines.find('#xifrarSpan').length === 0) {
        
		// Afegim el botó per a xifrar
		var opcionsXifrat = '<span id="xifrarSpan" class="btn-group" style="float:right"><a class="btn" href="#" id="xifrar"><img style="margin-right: 5px" src="'+chrome.extension.getURL("images/locked.png")+ '" width=13 height=13 />Xifrar</a></span>';
		taulaEines.find('.n1tfz :nth-child(6)').after('<td class="gU" style="min-width: 80px;">' + opcionsXifrat + '</td>');
 		taulaEines.find('#xifrar').click({action: "xifrar"}, callBackground);
      }
    });
  }

  // Afegeix l'opció de desxifrar
  var viewTitleBar = rootElement.find('td[class="gH acX"]');
  if (viewTitleBar && viewTitleBar.length > 0) {
    viewTitleBar.each(function(v) {
      if ($(this).find('#desxifrarSpan').length === 0) {
        //$(this).prepend('<span id="desxifrarSpan"><a class="btn" action="desxifrar" id="desxifrar"><img src="'+chrome.extension.getURL("images/unlocked.png")+ '" width=13 height=13 />Desxifrar</a></span>');
		//$(this).find('#desxifrar').click({action: "desxifrar"}, desxifrar);
        //$(this).append('<form class="form-inline"><input type="password" class="input-small" placeholder="contrassenya" id="passwordDesxifrat"></form>');
		$(this).append('<span id="desxifrarSpan" width="100px"><form class="form-inline"><input type="password" class="input-small" placeholder="password" id="passwordDesxifrat"></form><a class="btn" action="desxifrar" id="desxifrar"><img src="'+chrome.extension.getURL("images/unlocked.png")+ '" width=13 height=13 style="margin-right: 5px"/>Desxifrar</a></span>');
        $(this).find('#desxifrar').click({action: "desxifrar"}, desxifrar);
      }
    });
  }

  var alertaModal = $('#missatgeModal');
  if(alertaModal && alertaModal.length === 0) {
	// Afegim al cos del HTML l'alerta modal oculta. Es mostrarà més endavant en cas d'error
    $('.aAU').append('<div id="missatgeModal" class="modal hide fade" tabindex=-1 role="dialog"><div class="modal-header">' +
                     '<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>' +
                     '<h3>Error</h3></div><div id="cosMissatgeModal" class="modal-body"></div></div>');
    $('#missatgeModal').click(function() {
      $('#missatgeModal').modal('hide');
    });
  }
}

// Funció que comprova si l'usuari a polsat el botó per a redactar un correu
var animationListener = function(event) {
  if (event.animationName == "composeInserted") {
    composeInserted();
  }
};

// Per a sapiguer quan l'usuari ha polsat el botó per a redactar un correu, hem afegit una animació
// molt curta (0.001s) a la taula d'eines (class=".n1tfz") de la finestra de redacció. D'aquesta manera
// afegim els botons corresponents
document.addEventListener("webkitAnimationStart", animationListener, false);
